## mingw-w64-python-cx-freeze-8.1.0-1.src.tar.zst

=== Makefile ===
# Makefile to automate some tools
SHELL=/bin/bash
PATH := $(shell python -c "import sysconfig; print(sysconfig.get_path('scripts'))"):$(PATH)

BUILDDIR := ./build
PY_PLATFORM := $(shell python -c "import sysconfig; print(sysconfig.get_platform())")
PRE_COMMIT_OPTIONS := --show-diff-on-failure --color=always --all-files --hook-stage=manual

.PHONY: all
all: install

.PHONY: pre-commit
pre-commit: install
	@(pre-commit run $(PRE_COMMIT_OPTIONS) || true) | more
	@pre-commit gc

.PHONY: pylint
pylint:
	uvx pylint cx_Freeze

.PHONY: clean
clean: uninstall
	@$(MAKE) -C doc clean
	@rm -f .coverage .backup_coverage || true

.PHONY: install
install:
ifeq ($(PY_PLATFORM),win-amd64)
	if ! which uv; then\
		python -m pip install --upgrade uv --disable-pip-version-check;\
	fi
else
	curl -LsSf https://astral.sh/uv/install.sh | \
	env UV_INSTALL_DIR="$(HOME)/bin" INSTALLER_NO_MODIFY_PATH=1 sh
endif
	if ! which pre-commit || ! [ -f .git/hooks/pre-commit ]; then\
		uv pip install --extra dev --extra doc --upgrade -r pyproject.toml &&\
		pre-commit install --install-hooks --overwrite -t pre-commit;\
	fi

.PHONY: uninstall
uninstall:
	@if which pre-commit && [ -f .git/hooks/pre-commit ]; then\
		pre-commit clean;\
		pre-commit uninstall;\
		rm -f .git/hooks/pre-commit;\
	fi

.PHONY: upgrade
upgrade: clean install
	pre-commit autoupdate
	$(MAKE) pre-commit

.PHONY: html
html:
	uv pip install --extra doc --upgrade -r pyproject.toml
	@if which pre-commit && [ -f .git/hooks/pre-commit ]; then\
		pre-commit run blacken-docs $(PRE_COMMIT_OPTIONS);\
		pre-commit run build-docs $(PRE_COMMIT_OPTIONS);\
	else\
		$(MAKE) -C doc html;\
	fi

.PHONY: htmltest
htmltest:
	$(MAKE) -C doc test

.PHONY: doc
doc: html
	$(MAKE) -C doc epub
	$(MAKE) -C doc pdf

.PHONY: install_pytest
install_pytest:
	uv pip install --extra tests --upgrade -r pyproject.toml
	./ci/build-wheel.sh

.PHONY: tests
tests: install_pytest
	pytest -nauto --no-cov

.PHONY: cov
cov: install_pytest
	@rm -rf $(BUILDDIR)/coverage_html_report
	@if [ -f .coverage ]; then mv .coverage .backup_coverage; fi
	pytest -nauto --cov="cx_Freeze" --cov-report=html
	coverage report
	@python -m webbrowser -t $(BUILDDIR)/coverage_html_report/index.html
	@if [ -f .backup_coverage ]; then coverage combine -a .backup_coverage; fi

.PHONY: cov2
cov2: install_pytest
	@rm -rf $(BUILDDIR)/coverage_html_report
	@if [ -f .coverage ]; then mv .coverage .backup_coverage; fi
	pytest -nauto --cov="cx_Freeze" || true
ifeq ($(PY_PLATFORM),win-amd64)
	# Extra coverage for Windows
	# test without lief (LIEF_DISABLED)
	CX_FREEZE_BIND=imagehlp \
	pytest -nauto --cov="cx_Freeze" --cov-append \
		tests/test_command_build.py tests/test_command_build_exe.py \
		tests/test_winversioninfo.py || true
	# test lief min version
	uv pip install "lief==0.13.2"
	pytest -nauto --cov="cx_Freeze" --cov-append \
		tests/test_command_build.py tests/test_command_build_exe.py \
		tests/test_winversioninfo.py || true
	# test lief 0.14
	uv pip install "lief==0.14.1"
	pytest -nauto --cov="cx_Freeze" --cov-append \
		tests/test_command_build.py tests/test_command_build_exe.py \
		tests/test_winversioninfo.py || true
	# test lief 0.15
	uv pip install "lief==0.15.1"
	pytest -nauto --cov="cx_Freeze" --cov-append \
		tests/test_command_build.py tests/test_command_build_exe.py \
		tests/test_winversioninfo.py || true
	# test lief 0.16
	uv pip install "lief==0.16.2"
	pytest -nauto --cov="cx_Freeze" --cov-append \
		tests/test_command_build.py tests/test_command_build_exe.py \
		tests/test_winversioninfo.py || true
	# coverage winversioninfo using pywin32
	uv pip install --upgrade pywin32
	pytest -nauto --cov="cx_Freeze" --cov-append \
		tests/test_winversioninfo.py || true
	uv pip uninstall pywin32
	uv pip install lief --upgrade
endif
	@if [ -f .backup_coverage ]; then coverage combine -a .backup_coverage; fi
	coverage report
	coverage html --title="Multiple coverage reports"
	@python -m webbrowser -t $(BUILDDIR)/coverage_html_report/index.html

.PHONY: release
release:
	bump-my-version show-bump 2>/dev/null
	@echo "Run:"
	@echo "  bump-my-version bump <option>"
	@echo "--or--"
	@echo "  bump-my-version bump patch --new-version=X.XX.X"
	@echo "--then--"
	@echo "  git push origin `git branch --show-current` --tags"

.PHONY: release-dev
release-dev:
	if (grep "current_version" pyproject.toml | grep -q "\-dev"); then\
		bump-my-version bump --allow-dirty --no-tag build;\
	else\
		bump-my-version bump --allow-dirty --no-tag minor;\
	fi
	git log -1

=== requirements.txt ===
filelock>=3.12.3
packaging>=24
setuptools>=65.6.3,<=78.1.0
tomli>=2.0.1 ;python_version < '3.11'
typing_extensions>=4.10.0 ;python_version < '3.10'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'x86_64'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'i686'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'aarch64'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'armv7l'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 'ppc64le'
patchelf>=0.14 ;sys_platform == 'linux' and platform_machine == 's390x'
dmgbuild>=1.6.1 ;sys_platform == 'darwin'
cabarchive>=0.2.4 ;sys_platform == 'win32'
cx_Logging>=3.1 ;sys_platform == 'win32'
lief>=0.13.2,<=0.16.4 ;sys_platform == 'win32'
striprtf>=0.0.26 ;sys_platform == 'win32'

=== doc/requirements.txt ===
sphinx==7.4.7
sphinx-new-tab-link==0.8.0
sphinx-tabs==3.4.7
furo==2024.8.6
myst-parser>=3.0.1,<=4.0.1

=== tests/requirements.txt ===
pytest==8.3.5
pluggy==1.5.0
pytest-cov==6.1.0
coverage==7.8.0
pytest-datafiles==3.0.0
pytest-mock==3.14.0
pytest-timeout==2.3.1
pytest-xdist==3.6.1

=== PKGBUILD ===
# Maintainer: Marcelo Duarte https://github.com/marcelotduarte
# Maintainer: Frode Solheim <frode@fs-uae.net>
# Contributor: Duong Pham <dthpham@gmail.com>
# Contributor: Lara Maia <dev@lara.click>

_realname=cx-freeze
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=8.1.0
pkgrel=1
pkgdesc="Creates standalone executables from Python scripts, with the same performance (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/marcelotduarte/cx_Freeze/"
msys2_references=(
  'purl: pkg:pypi/cx-freeze'
)
license=('spdx:PSF-2.0')
depends=(
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-python-filelock"
  "${MINGW_PACKAGE_PREFIX}-python-packaging"
  "${MINGW_PACKAGE_PREFIX}-python-pip"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-python-cx-logging"
)
if [ "${CARCH}" != "aarch64" ]; then
    depends+=("${MINGW_PACKAGE_PREFIX}-python-lief")
fi
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-tools"
)
checkdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-pytest"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-cov"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-datafiles"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-mock"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-timeout"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-xdist"
)
options=(!strip)
source=(
  #"https://pypi.org/packages/source/${_realname::1}/${_realname/-/_}/${_realname/-/_}-${pkgver}.tar.gz"
  "${url}/archive/refs/tags/${pkgver}.tar.gz"
)
sha256sums=(
  '45d82f7e541ae4fb05ed4250c03a84f969ba94a43bac0112a86c0b7793a12c3b'
)

prepare() {
  cd "${srcdir}"/cx_Freeze-${pkgver}
  # ignore version check for setuptools
  sed -i 's/"setuptools>=.*"/"setuptools"/' pyproject.toml
  sed -i 's/"cabarchive>=.*"/#"cabarchive"/' pyproject.toml
  sed -i 's/"striprtf>=.*"/#"striprtf"/' pyproject.toml

  rm -Rf "${srcdir}"/python-${_realname}-${MSYSTEM}
  cp -a "${srcdir}"/cx_Freeze-${pkgver} "${srcdir}"/python-${_realname}-${MSYSTEM}
}

build() {
  cd python-${_realname}-${MSYSTEM}
  ${MINGW_PREFIX}/bin/python -m build --wheel --skip-dependency-check --no-isolation
}

check() {
  cd python-${_realname}-${MSYSTEM}
  ${MINGW_PREFIX}/bin/pip install cx_Freeze -f dist --no-deps --no-index
  ${MINGW_PREFIX}/bin/pytest -nauto --cov="cx_Freeze"
}

package() {
  cd python-${_realname}-${MSYSTEM}
  MSYS2_ARG_CONV_EXCL="--prefix=" \
    ${MINGW_PREFIX}/bin/python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" dist/*.whl
  install -Dm644 LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/LICENSE.md"
}
